// See http://www.remote.org/frederik/ziege/ for an exlpanation.
// Written by Frederik Ramm, March 1999
// --------------------------------------------------------------

package org.remote.frederik.ziege;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;

public final class ZiegeApplet extends Applet 
implements ActionListener, Runnable {


// Sets up the GUI.

public void init() {

   String resetString, singleString;
   String lastString;
   String carString, choiceString, modString, changeString, winString;
   String sumString, countGString, countWString, percWString, percCString;

   if (getParameter("lang").equals("de")) {
      yesString =    "Ja";
      noString  =    "Nein";
      runString =    "Dauerspiel";
      stopString =   "Anhalten";
      resetString =  "Zurcksetzen";
      singleString = "Einzelspiel";
      lastString =   "Letztes Spiel:";
      carString =    "Auto hinter Tr";
      choiceString = "Kandidat whlt"; 
      modString =    "Moderator ffnet";
      changeString = "Kandidat wechselt";
      winString =    "Gewinn";
      sumString =    "Summen:";
      countGString = "Anzahl Spiele";
      countWString = "Anzahl Siege";
      percWString =  "Anteil der Siege an allen Spielen:";
      percCString =  "Anteil der Wechsel an den Siegen:";
   } else {
      yesString =    "yes";
      noString  =    "no";
      runString =    "Continuous game";
      stopString =   "Stop";
      resetString =  "Reset";
      singleString = "Single game";
      lastString =   "Last game:";
      carString =    "Car behind door #";
      choiceString = "Candidate chooses #";
      modString =    "Host opens #"; 
      changeString = "Candidate switches";
      winString =    "Win";
      sumString =    "Sums:";
      countGString = "Number of games";
      countWString = "Victory count";
      percWString =  "Victories among games:";
      percCString =  "If victory, candidate switched:";
   }

   setLayout(new SimpleGridBag());

   Panel panel = new Panel();
   add(new Label(lastString, Label.LEFT), "x=0 y=0 a=w");

   panel.setLayout(new SimpleGridBag());
   panel.add(new Label(carString), "x=0 y=0 f=h wx=.5 il=3");
   panel.add(lastCar = new Label("-", Label.RIGHT), "f=h wx=.5 ir=3");
   panel.add(new Label(choiceString), "nl f=h il=3");
   panel.add(lastChoice = new Label("-", Label.RIGHT), "f=h ir=3");
   panel.add(new Label(modString), "nl f=h il=3");
   panel.add(lastMod = new Label("-", Label.RIGHT), "f=h ir=3");
   panel.add(new Label(changeString), "nl f=h il=3");
   panel.add(lastChange = new Label("-", Label.RIGHT), "f=h ir=3");
   panel.add(new Label(winString), "nl f=h il=3");
   panel.add(lastWin = new Label("-", Label.RIGHT), "f=h ir=3");
   add(new Border(panel, 2), "x=0 y=1 f=h ir=3 wx=.5");

   add(new Label(sumString, Label.LEFT), "x=1 y=0 a=w");
   panel = new Panel();
   panel.setLayout(new SimpleGridBag());
   panel.add(new Label(countGString), "x=0 y=0 f=h wx=.5 il=3");
   panel.add(sumGames = new Label("-", Label.RIGHT), "f=h wx=.5");
   panel.add(new Label(countWString), "nl f=h il=3");
   panel.add(sumWins = new Label("-", Label.RIGHT), "f=h");
   panel.add(new Label(percWString), "nl w=2 a=w il=3");
   panel.add(wins= new ProgressBar(), "nl f=h w=2 il=3 ir=3");
   panel.add(new Label(percCString), "nl w=2 a=w il=3");
   panel.add(winsWithChange = new ProgressBar(), "nl f=h w=2 il=3 ir=3");
   add(new Border(panel, 2), "x=1 y=1 f=h il=3 wx=.5");

   panel = new Panel();
   panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
   panel.add(resetButton = new Button(resetString));
   panel.add(stepButton = new Button(singleString));
   panel.add(runButton = new Button(runString));
   resetButton.addActionListener(this);
   stepButton.addActionListener(this);
   runButton.addActionListener(this);
   add(panel, "x=0 y=2 w=2 f=h");

   rnd = new java.util.Random();
}

// Simulates one game round.

private void round() {

   // Determine the door where the sports car is (randomly)
   int car     = posInt() % 3 + 1;
   lastCar.setText(Integer.toString(car));

   // Determine the door selected by the candidate (randomly)
   int choice  = posInt() % 3 + 1;
   lastChoice.setText(Integer.toString(choice));

   // Determine which door the host opens
   int mod;
   if (car != choice) {
      // there's only one door left
      mod = 6 - car - choice;
   } else {
      // there are two possible doors - select one randomly
      mod = (choice + 1 + posInt() % 2);
      if (mod > 3) mod -= 3;
   }
   lastMod.setText(Integer.toString(mod));

   // in this simulation, the candidate chooses randomly if he wants to
   // change or not
   boolean change = ((posInt() % 2) == 0);
   lastChange.setText(change ? yesString: noString);

   // candidate wins if he chose the right door and does not change, 
   // or if he chose the wrong door and changes
   boolean win = (car == choice) ^ change;
   lastWin.setText(win ? yesString : noString);

   if (win) {
      if (change) countWinWithChange++; else countWinWithoutChange++;
   }
   spielZahl++;
   sumGames.setText(Integer.toString(spielZahl));
   winsWithChange.setMax(countWinWithChange+countWinWithoutChange);
   winsWithChange.setValue(countWinWithChange);
   sumWins.setText(Integer.toString(countWinWithChange+countWinWithoutChange));
   wins.setMax(spielZahl);
   wins.setValue(countWinWithChange+countWinWithoutChange);

};

// Generate a positive integer

private int posInt() { 

   int rv;
   rv=rnd.nextInt();
   if (rv<0) rv=-rv;
   return(rv);

};
      
// process button clicks.

public void actionPerformed(ActionEvent e) {

   if (e.getSource() == runButton) {
      if (running) {
         runButton.setLabel(runString);
         stepButton.setEnabled(true);
         resetButton.setEnabled(true);
      } else {
         runButton.setLabel(stopString);
         stepButton.setEnabled(false);
         resetButton.setEnabled(false);
         thread = new Thread(this);
         thread.start();
      }
      running = !running;
   } else if (e.getSource() == resetButton) {
      lastCar.setText("-");
      lastChoice.setText("-");
      lastMod.setText("-");
      lastChange.setText("-"); 
      lastWin.setText("-"); 
      sumGames.setText("-"); 
      sumWins.setText("-"); 
      winsWithChange.setMax(0); 
      winsWithChange.setValue(0); 
      wins.setMax(0); 
      wins.setValue(0); 
      spielZahl = countWinWithChange = countWinWithoutChange = 0;
   } else {
      round();
   }
}

public void run() {

   while(running) round();
   destroy();

}

int countWinWithChange;
int countWinWithoutChange;
int spielZahl;
boolean running = false;
Label lastCar;
Label lastChoice;
Label lastMod;
Label lastChange;
Label lastWin;
Label sumGames;
Label sumWins;
ProgressBar wins, winsWithChange;
Button stepButton, runButton, resetButton;
Thread thread = null;
java.util.Random rnd;

String yesString, noString, runString, stopString;

}
